/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

function raton_liberado(evento) {

	if(!blok){

		if(dialogo.tag!=-1){
			if(dialogo.opcion_apuntada==0){ //ACEPTAR
				url_redireccionar="nuevo_miembro_"+band_requests.requests[0][1];
				bloquear();				
				mark_grid(0,0,GRID_COLUMNS-1,GRID_ROWS-1);
				fadeout_alpha=0.0;
			}else if(dialogo.opcion_apuntada==1){ //RECHAZAR
				url_redireccionar="borrar_peticion_"+band_requests.requests[0][1]+"_0";
				bloquear();				
				mark_grid(0,0,GRID_COLUMNS-1,GRID_ROWS-1);
				fadeout_alpha=0.0;				
			}
			dialogo.tag=-1;
		}else if(chooser.tag!=-1){
			if(chooser.opcion_apuntada!=-1){
				if(chooser.tag==TAG_GUITAR){
					escenario.objetos[chooser.tag][chooser.opcion_apuntada].x=escenario.objetos[TAG_GUITAR][escenario.guitarra_activa].x;
					escenario.objetos[chooser.tag][chooser.opcion_apuntada].y=escenario.objetos[TAG_GUITAR][escenario.guitarra_activa].y;
					escenario.objetos[chooser.tag][chooser.opcion_apuntada].escala=escenario.objetos[TAG_GUITAR][escenario.guitarra_activa].escala;
					escenario.guitarra_activa=chooser.opcion_apuntada;
				}
			}
			chooser.tag=-1;
		}else if(down_time>=MAX_DOWN_TIME && objeto_destacado!=-1 && escenario.objetos[tag_destacado][objeto_destacado].draggable){			
			//Estamos arrastrando el raton
			escenario.objetos[tag_destacado][objeto_destacado].dragged=0;
		}else{
			//Adaptamos las coordenadas del evento
			var x_evento=adaptar_x_evento(evento);
			var y_evento=adaptar_y_evento(evento);

			if(menu_button_pointed==1){
				bloquear();				
				mark_grid(0,0,GRID_COLUMNS-1,GRID_ROWS-1);
				fadeout_alpha=0.0;
				url_redireccionar="/logout/";
			}else if(menu_button_pointed==0){
				bloquear();				
				mark_grid(0,0,GRID_COLUMNS-1,GRID_ROWS-1);
				fadeout_alpha=0.0;
				url_redireccionar="/bands/";
			}else if(boton_destacado!=-1){ //Estamos interactuando con un boton
				lanzar_dialogo(ANCHURA_VENTANA/2-150,ALTURA_VENTANA/2-100,TAG_BAND_REQUEST);
			}else if(objeto_destacado!=-1){ //Estamos interactuando con un objeto
				if(tag_destacado==TAG_PHONE){
					lanzar_bocadillo_contestador();
				}else{
					lanzar_chooser(400,75,tag_destacado);
				}
			}else{ //Estamos moviendonos
				//Controlamos que no se nos salga de los margenes
				var n_areas=escenario.area.length;
				var area_destino; //Area al que queremos ir
				area_actual=calcular_area(jugador.getX()); //Area en el que estamos
				var xdest;
				var ydest;
								
				area_destino=calcular_area(x_evento);

				if(area_destino==0 && x_evento<escenario.area[0][0])
						xdest=escenario.area[0][0];
				else if(area_destino==n_areas-1)
						xdest=escenario.area[n_areas-1][0];
				else
						xdest=x_evento;

				if(y_evento>escenario.area[area_destino][1])
						ydest=y_evento;
				else
						ydest=escenario.area[area_destino][1];
						
				//Creamos una nueva ruta
				ruta = new Ruta(jugador.getX(),jugador.getY(),xdest,ydest,area_actual,area_destino);
						
				if(ruta.getX()<jugador.getX())
					jugador.direccion_x=1;
				else if(ruta.getX()>jugador.getX())
					jugador.direccion_x=2;
					
				if(ruta.getY()<jugador.getY())
					jugador.direccion_y=1;
				else if(ruta.getY()>jugador.getY())
					jugador.direccion_y=2;
			}
		}
		
		//Ya no estamos arrastrando el raton
		down=0;
		down_time=0;
	}
}

function raton_movido(evento){

	if(!blok){
    
		//Adaptamos las coordenadas del evento
		var x_evento=adaptar_x_evento(evento);
		var y_evento=adaptar_y_evento(evento);
		
		//Estamos arastrando el raton
		if(down && down_time>=MAX_DOWN_TIME){
			if(objeto_destacado!=-1 && escenario.objetos[tag_destacado][objeto_destacado].draggable){
				//Marcamos el objeto como arrastrado
				escenario.objetos[tag_destacado][objeto_destacado].dragged=1;
				//Controlamos que no se nos salga de los margenes
				var n_areas=escenario.area.length;
				var area=calcular_area(x_evento);
				var xdest;
				var ydest;

				if(area==0 && x_evento<escenario.area[0][0])
						x_evento=escenario.area[0][0];
				else if(area==n_areas-1)
						x_evento=escenario.area[n_areas-1][0];

				if(y_evento<escenario.area[area][1])
						y_evento=escenario.area[area][1];
						
				escenario.objetos[tag_destacado][objeto_destacado].x=x_evento-escenario.objetos[tag_destacado][objeto_destacado].width/2;
				escenario.objetos[tag_destacado][objeto_destacado].y=y_evento-escenario.objetos[tag_destacado][objeto_destacado].height;
				escenario.objetos[tag_destacado][objeto_destacado].escala=0.5+escenario.objetos[tag_destacado][objeto_destacado].y/ALTURA_EFECTIVA;
			}
		}else{	//No estamos arrastrando el raton
			if(dialogo.tag!=-1){
				dialogo.opcion_apuntada=-1;
				for(i=0;i<dialogo.coordenadas_opciones.length;i++){
					var x1=dialogo.coordenadas_opciones[i][0];
					var x2=x1+dialogo.opcion_w;
					var y1=dialogo.coordenadas_opciones[i][1];
					var y2=y1+dialogo.opcion_h;
					if(x_evento>=x1 && x_evento<=x2 && y_evento>=y1 && y_evento<=y2)
						dialogo.opcion_apuntada=i;
				}				
			}else if(chooser.tag!=-1){
				chooser.opcion_apuntada=-1;
				for(i=0;i<chooser.opcion_x.length;i++){
					var x1=chooser.opcion_x[i];
					var x2=x1+chooser.opcion_w;
					var y1=chooser.y+chooser.margen;
					var y2=y1+chooser.opcion_h;
					if(x_evento>=x1 && x_evento<=x2 && y_evento>=y1 && y_evento<=y2)
						chooser.opcion_apuntada=i;
				}
			}else if(y_evento>MENU_MARGIN){
				//Ya no estamos apuntando a algun boton del menu
				menu_button_pointed=-1;
				//Comprobamos si estamos pasando por encima de un boton
				destacar_botones(x_evento,y_evento);
				//Replegamos el menu
				if(menu.estado==DESPLEGAR_MENU)
					menu.estado=REPLEGAR_MENU;
			}else{
				//Desplegamos el menu
				menu.estado=DESPLEGAR_MENU;
				//Destacamos los botones del menu
				destacar_botones_menu(x_evento,y_evento);
			}
		}
	}
}

function mouse_down(evento) {

	if(!blok){
		down=1;
	}
}